<template>
  <v-row no-gutters>
    <v-col>
      <v-img :src="images.whitebg" height="100vh">
        <v-container fill-height>
          <v-row justify="end">
            <v-col cols="12">
              <v-card max-width="400" class="login-card" elevation="5" v-if="!loadbg">
                <v-card-text v-if="tokenvalid">
                  <div class="login-title">
                    <h2 @click="goHome()">Cuidémonos</h2>
                    <h3>Recuperar contraseña</h3>
                  </div>
                  <v-form ref="form" v-model="valid" class="my-8">
                    <v-text-field
                      label="Nueva contraseña"
                      v-model="newPassword"
                      type="password"
                      :rules="passwordRules"
                      required
                      outlined
                    ></v-text-field>
                    <v-btn
                      block
                      height="50"
                      rounded
                      color="primary"
                      @click="resetPassword"
                      :loading="loading"
                      >Cambiar contraseña</v-btn
                    >
                  </v-form>
                </v-card-text>
                <v-card-text v-else>
                  <div class="login-title">
                    <h2 @click="goHome()">Cuidémonos</h2>
                    <h3>
                      <span class="error--text">El token es inválido</span>
                    </h3>
                  </div>
                  <v-form ref="form" v-model="valid" class="my-8">
                    <v-btn block height="50" rounded color="primary" to="/"
                      >Ir al inicio</v-btn
                    >
                  </v-form>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-container>
      </v-img>
      <HomeDialog v-model="modal" text="Contraseña actualizada"/>
    </v-col>
  </v-row>
</template>
<script>
import { mapActions } from "vuex";
import jwt_decode from "jwt-decode";
import HomeDialog from "~/components/Dialogs/HomeDialog";
import images from "~/assets/js/images";

export default {
  layout: "simple",
  data() {
    return {
      newPassword: "",
      token: "",
      images,
      modal: false,
      valid: false,
      loadbg: true,
      tokenvalid: false,
      loading: false,
      passwordRules: [(v) => !!v || "La contraseña es obligatoria"],
    };
  },
  components: {
    HomeDialog,
  },
  mounted() {
    const token = this.$route.params.token;
    if (this.decode(token)) this.tokenvalid = true;
    this.loadbg = false;
  },
  methods: {
    resetPassword() {
      this.$refs.form.validate();
      const payload = { newPassword: this.newPassword, token: this.token };
      if (this.valid) {
        this.resetPasswordState({ payload });
        this.modal = true;
      }
    },
    ...mapActions({
      resetPasswordState: "auth/resetPassword",
    }),
    decode(token) {
      try {
        const user = jwt_decode(token);
        this.token = token;
        return user;
      } catch {
        return null;
      }
    },
    goHome() {
      this.$router.push("/");
    },
  },
};
</script>
<style scoped lang="scss">
.login-card {
  padding: 50px 20px;
  border-radius: 20px;
  margin: 0 auto;
}
.login-title {
  margin-bottom: 40px;
  text-align: center;
  h2 {
    font-size: 35px;
    color: #1ecd96 !important;
    margin-bottom: 15px;
    cursor: pointer;
  }
  h3 {
    letter-spacing: 1.04px;
  }
}
</style>
